<template>
  <div class="container-fluid catalogs content">
    <h1 class="row col-12 page-title">
      {{ showSubCatalogs ? getTranslationFor(getCatalog.title, $route.query.locale, getCatalog.languages) : $t("message.header.navigation.data.catalogs") }}
    </h1>
    <div class="row">
      <catalogues-facets
        v-if="useCatalogFacets"
        class="col-md-3 col-12 mb-3 mb-md-0 px-0"
      />
      <catalogues-content />
    </div>
    <div class="row">
      <div class="column col-12 col-md-9 offset-md-3">
        <pagination
          class="mt-3"
          :items-count="getCatalogsCount"
          :items-per-page="getLimit"
          :get-page="getPage"
          :get-page-count="getPageCount"
          @setPageLimit="setPageLimit"
        ></pagination>
      </div>
    </div>
  </div>
</template>

<script>
import $ from "jquery";
import { mapActions, mapGetters } from "vuex";
import { debounce, has } from "lodash-es";
import {
  CataloguesFacets,
  Pagination,
  dateFilters,
  fileTypes,
  helpers,
} from "@piveau/piveau-hub-ui-modules";
import CataloguesContent from "@/components/search/catalogues/CataloguesContent";
const { getImg, getCountryFlagImg, getTranslationFor } = helpers;

export default {
  name: "ECCatalogues",
  components: {
    CataloguesContent,
    CataloguesFacets,
    Pagination
  },
  props: {
    infiniteScrolling: {
      type: Boolean,
      default: false,
    }
  },
  metaInfo() {
    return {
      titleTemplate() {
        return this.$t("message.catalogs.meta.page.title");
      },
      meta: [
        {
          name: "description",
          vmid: "description",
          content: `${this.$t(
            "message.catalogs.meta.description"
          )}`,
        },
        {
          name: "keywords",
          vmid: "keywords",
          content: `${this.$env.keywords} ${this.$t(
            "message.catalogs.meta.description"
          )}`,
        },
        { name: "robots", content: "index, follow" },
      ],
    };
  },
  data() {
    return {
      debouncedOnBottomScroll: debounce(this.onBottomScroll, 500),
      facetFields: [],
      useCatalogFacets: this.$env.content.catalogs.facets.useCatalogFacets,
    };
  },
  computed: {
    ...mapGetters('catalogDetails', [
      'getCatalog',
    ]),
    ...mapGetters("catalogs", [
      "getCatalogsCount",
      "getLimit",
      "getPage",
      "getPageCount"
    ]),
    facets() {
      const facets = {};
      for (const field of this.facetFields) {
        let urlFacets = this.$route.query[field];
        if (!urlFacets) urlFacets = [];
        else if (!Array.isArray(urlFacets)) urlFacets = [urlFacets];
        facets[field] = urlFacets;
      }
      return facets;
    },
    // isErpdActive() {
    //   const cat = 'erpd';
    //   const sc = this.$route.query.superCatalog;
    //   if (sc === cat) return true;
    //   return sc?.constructor === Array && sc.length > 0 && sc[0] === cat;
    // },
    showSubCatalogs() {
      return this.$route.query.showsubcatalogs;
    }
  },
  methods: {
    ...mapActions("catalogs", [
      "loadCatalogs",
      "loadAdditionalCatalogs",
      "setPage",
      "addFacet",
      "setFacets",
      "setFacetOperator",
      "setFacetGroupOperator",
      "setPageCount",
      "setLimit",
      "setSort",
      "setLoading"
    ]),
    has,
    getImg,
    getTranslationFor,
    getCountryFlagImg,
    datasetsRoute(catalogId) {
      return {
        path: `/catalogues/${catalogId}`,
        query: {
          locale: this.$route.query.locale
        }
      }
    },
    initLimit() {
      const limit = parseInt(this.$route.query.limit, 10);
      if (limit > 0) this.setLimit(limit);
    },
    initSort() {
      const sort = this.$route.query.sort;
      if (sort) this.setSort(sort);
    },
    setPageLimit(value) {
      this.setLimit(value);
      this.initCatalogues();
    },
    initPage() {
      const page = parseInt(this.$route.query.page, 10);
      if (page > 0) this.setPage(page);
      else this.setPage(1);
    },
    initFacetOperator() {
      const op = this.$route.query.facetOperator;
      if (op === "AND" || op === "OR") this.setFacetOperator(op);
    },
    initFacetGroupOperator() {
      const op = this.$route.query.facetOperator;
      if (op === "AND" || op === "OR") this.setFacetGroupOperator(op);
    },
    initFacets() {
      const fields = this.$env.content.catalogs.facets.defaultFacetOrder;
      for (const field of fields) {
        this.facetFields.push(field);
        if (!Object.prototype.hasOwnProperty.call(this.$route.query, [field])) {
          this.$router.replace({
            query: Object.assign({}, this.$route.query, {[field]: []}),
          });
        } else {
          for (const facet of this.$route.query[field]) {
            this.addFacet({field, facet});
          }
        }
      }
    },
    initCatalogues() {
      this.$nextTick(() => {
        this.$Progress.start();
        this.loadCatalogs({})
          .then(() => {
            this.setPageCount(Math.ceil(this.getCatalogsCount / this.getLimit));
            this.$Progress.finish();
            $('[data-toggle="tooltip"]').tooltip({
              container: "body",
            });
          })
          .catch(() => this.$Progress.fail())
          .finally(() => this.$root.$emit('contentLoaded'));
      });
    },
    initInfiniteScrolling() {
      if (this.infiniteScrolling)
        window.addEventListener("scroll", this.onScroll);
    },
    handleSuggestionSelection(suggestion) {
      this.$router.push({
        path:
          this.$route.path.slice(-1) === "/"
            ? `${this.$route.path}${suggestion.idName}`
            : `${this.$route.path}/${suggestion.idName}`,
      });
    },
    onScroll() {
      const items = this.$el.querySelectorAll(".catalog");
      const lastItem = items[items.length - 1];
      if (lastItem) {
        const lastItemPos = lastItem.getBoundingClientRect();
        if (lastItemPos.bottom - window.innerHeight <= 0) {
          this.debouncedOnBottomScroll();
        }
      }
    },
    onBottomScroll() {
      this.$nextTick(() => {
        this.$Progress.start();
        this.setLoading(true);
        this.loadAdditionalCatalogs()
          .then(() => {
            this.$Progress.finish();
            this.setLoading(false);
          })
          .catch(() => {
            this.$Progress.fail();
            this.setLoading(false);
          });
      });
    },
    removeDuplicatesOf(array) {
      return [...new Set(array)];
    },
    getFileTypeColor(format) {
      return fileTypes.getFileTypeColor(format);
    },
    filterDateFormatUS(date) {
      return dateFilters.formatUS(date);
    },
    filterDateFormatEU(date) {
      return dateFilters.formatEU(date);
    },
    filterDateFromNow(date) {
      return dateFilters.fromNow(date);
    },
    getCatalogLink(catalog) {
      return `/catalogues/${catalog.id}&locale=${this.$route.query.locale}`;
    },
    getCatalogImage(catalog) {
      return this.$env.content.catalogs.useCatalogCountries
        ? `${this.$env.content.catalogs.defaultCatalogImagePath}/${
          has(catalog, "country.id")
            ? catalog.country.id
            : this.$env.content.catalogs.defaultCatalogCountryID
        }`
        : `${this.$env.content.catalogs.defaultCatalogImagePath}/${
          has(catalog, "id")
            ? catalog.id
            : this.$env.content.catalogs.defaultCatalogID
        }`;
    },
    getFooterTags(catalog) {
      return [`${has(catalog, "count") ? catalog.count : 0}`];
    },
    getCatalogLanguages(catalog) {
      return has(catalog, "country.id")
        ? [catalog.country.id].concat(catalog.languages)
        : catalog.languages;
    },
    datasetsRouteQuery() {
      const sc = this.$route.query.superCatalog;
      if (sc === 'erpd' ||
        (sc?.constructor === Array && sc.length > 0 && sc[0] === 'erpd')) {
        return {superCatalog: 'erpd', locale: this.$route.query.locale};
      } else {
        return {locale: this.$route.query.locale};
      }
    }
  },
  watch: {
    facets: {
      handler(facets) {
        this.setFacets(facets);
      },
      deep: true,
    },
    page(pageStr) {
      const page = parseInt(pageStr, 10);
      if (page > 0) this.setPage(page);
      else this.setPage(1);
    }
  },
  created() {
    this.initLimit();
    this.initSort();
    this.initPage();
    this.initFacetOperator();
    this.initFacetGroupOperator();
    this.initFacets();
    this.initCatalogues();
    this.initInfiniteScrolling();
  },
  beforeDestroy() {
    $(".tooltip").remove();
    if (this.infiniteScrolling)
      window.removeEventListener("scroll", this.onScroll);
  },
};
</script>

<style lang="scss" scoped>
.alert-primary {
  color: #042648;
  background-color: #cddbe8;
  border-color: #baccdf;
}

.page-title {
  // maybe we can change custom theme h1 to 3rem
  font-size: 3rem;
  margin-bottom: 15px;
}

.search-button {
  border-radius: 100% !important;

  &:hover {
    background-color: #196fd2;
    border-color: #196fd2;
  }
}

.cursor-pointer {
  cursor: pointer;
}

.button-color-grey {
  background-color: rgba(0, 29, 133, 0.1) !important;
  color: black !important;
}

.custom-button {
  border: 1px solid black;
  background-color: white;
  outline: none;
}

.custom-middle-button {
  border: 1px solid black;
  border-left: none;
  background-color: white;
  outline: none;
}

.custom-dropdown-button {
  border: 1px solid black;
  padding: 0;
  background-color: white;
  outline: none;
}

.inactive-styles {
  color: rgba(0, 0, 0, 0.5);

  &:hover {
    background-color: rgb(247, 247, 247);
    color: black;
  }

  &:focus {
    background-color: rgb(247, 247, 247);
    color: black;
  }
}

.custom-border-right {
  border-right: 1px solid black;
}

.border-radius-start {
  border-top-left-radius: 1.875rem;
  border-bottom-left-radius: 1.875rem;
}

.border-radius-end {
  border-top-right-radius: 1.875rem;
  border-bottom-right-radius: 1.875rem;
}

.border-right-custom {
  padding-right: 0.5rem;
  border-right: 1px solid black;
}

.router-link-active {
  color: #7f7f7f !important;
  border: none !important;
  border-bottom: 2px solid #0e47cb !important;
  background-color: #0e47cb !important;

  &:hover{
    color: #fff !important;
  }
}

.router-link-inactive {
  color: #7f7f7f;
  border: none !important;

  &:hover {
    color: #0e47cb !important;
  }
}


.suggestion-input-group {
  position: relative;
}

.suggestion-input {
  position: absolute;
  top: 0;
}

.suggestion-list-group {
  position: relative;
  width: 100%;
}

.suggestion-list {
  width: 100%;
  position: absolute;
  top: 0;
  z-index: 100;
}

.api-custom {
  margin-top: 32px !important;
  border: none;
  background: none;
  padding: 0px;
}

@media screen and (max-width: 767.5px) {

  #btnGroupDrop1{
    border: none !important;
  }
}
</style>
